#ifndef _CAMERA_FG_STD_H
#define _CAMERA_FG_STD_H

#include "../camera_generic.h"
#include "framegrabber_generic.h"

namespace ipl{ // use namespace in C++

/** NB: Beta version, some of the functionality may be changed and
	parts of it may not work properly!!!
    CCameraFGStd is an abstract base class handling a frame grabber camera. It is
    derived from CCameraGeneric from which all camera classes are derived,
    last updated 17/01/2001. A Camera class is the only class needed to control
    shutter, gain, zoom and partial scan for the camera and grabbing
    an image. More advanced features should be found in the inherited
    classes. A frame grabber class attribute is available to control
	specific frame grabber functions. This class is not complete
	and a lot of changes in near future must be expected.
	At the moment no general derived classes exists.

    @see CCameraGeneric
	@version 0.16
	@author Ren Dencker Eriksen & Brian Kirstein Ramsgaard */

class CCameraFGStd : public CCameraGeneric{
	protected: // attributes
//		/// Initialized to false, set to true if Initialze() succeeds and to false if Close() succeeds.
//		bool m_DeviceOpen;
		/// Pointer to the frame grabber that the camera is connected to.
        CFrameGrabberGeneric *m_pFrameGrabberGeneric;
	public: // methods
		/// default constructor sets m_DeviceOpen to false, always call from derived constructor.
		CCameraFGStd();
		/// default destructor, calls Close() if m_DeviceOpen is true, always call from derived destructor.
		~CCameraFGStd();
        /** Constructor. Includes information about which frame grabber
			(and port on the frame grabber) the camera is connected to.
			@param fg pointer to framegrabber that is used.
			@param portNr the port number on fg that is used (default = 0).
			@return False, if initialization failed. */
        bool Initialize(CFrameGrabberGeneric& fg, unsigned short portNr=0);
		/** Implemented to fulfill the base class design. Call the other Initialize(...)
			method instead.
			@return False, always. Use Initialize(fg,PortNr) instead. */
		bool Initialize();
//		/** Returns true, if a previous call to Initialize() succeeded. Returns value of attribute 
//			m_DeviceOpen. */
//		inline bool IsDeviceOpen() const;
 		/** Acquire image from camera.
			@param Image The image taken by camera is returned in this parameter.
			@return False if grabbing failed. */
        bool Acquire(CStdImage& Image);
		/** Closes devices etc. if necessary, no need to overwrite if your derived class
			need not to close any devices. Calls associated framegrabber objects Close().
			@return Returns false if Close() on associated framegrabber fails. */
		virtual bool Close();
};

//inline bool CCameraFGStd::IsDeviceOpen() const
//{
//	return m_DeviceOpen;
//}

} // end namespace ipl

#endif //_CAMERA_FG_STD_H

