/*	File:	olfgdll.h

	Description:
		This file contains the public interface for the DT-Open
	Layers Frame Grabber Application Programming Interface.  This interface
	provides device dependent and operating system independent access
	to Data Translation frame grabbers.


*/
/*=======================================================================++
||	Copyright (C) 1994.         Data Translation, Inc., 100 Locke    ||
||	Drive, Marlboro, Massachusetts 01752-1192.			 ||
||									 ||
||	All rights reserved.  This software is furnished to purchaser	 ||
||	under a license for use on a single computer system and can be	 ||
||	copied (with the inclusion of DTI's copyright notice) only for	 ||
||	use in such system, except as may be otherwise provided in	 ||
||	writing by Data Translation, Inc., 100 Locke Drive, Marlboro,	 ||
||	Massachusetts 01752-1192.					 ||
||									 ||
||	The information in this document is subject to change without	 ||
||	notice and should not be construed as a commitment by Data	 ||
||	Translation, Inc.  Data Translation, Inc. assumes no		 ||
||	responsibility for any errors that may appear in this document.	 ||
||									 ||
||	Data Translation cannot assume any responsibility for the use	 ||
||	of any portion of this software on any equipment not supplied	 ||
||	by Data Translation, Inc.					 ||
||									 ||
++=======================================================================*/

#if !defined(OLFGDLL_H__)
#define OLFGDLL_H__ 1

#include "olwintyp.h"
#include "olimgdll.h"


/* Assume C declarations for C++ callers */
#ifdef __cplusplus
extern "C" {
#endif



/*=======================================================================*/
/*========================  Type Defintitions  ==========================*/
/*=======================================================================*/

/* "IDs" used by frame grabbers */
#define DECLARE_OL_FG_ID(type)		DECLARE_OL_HDL(FG, type, ID)

/* Frame ID */
DECLARE_OL_FG_ID(FRAME);

/* Async acquire job ID */
DECLARE_OL_FG_ID(ACQJOB);

/* Async passthru job ID */
DECLARE_OL_FG_ID(PASSJOB);



/*=======================================================================*/
/*=======================================================================*/
/*=======================  Prototypes  ==================================*/
/*=======================================================================*/
/*=======================================================================*/



/* End of extern "C" {  declaration for C++ callers */
#ifdef __cplusplus
}
#endif


#endif   /* OLFGAPI_H__*/
