#include "fireWireCam.h"

// static thread based stuff:

CCameraFirewireCMU * 	CM;
unsigned char 				img_a[640*480];
unsigned char 				img_b[640*480];
unsigned char 				img_c[640*480];
bool 							bNewThisFrame;
GLFWmutex 					mutex;


//------------------------------------
//------------------------------------
void GLFWCALL fireCamThread( void *arg ){

	bNewThisFrame = false;
		
	while (true) {
		
		Sleep(50);
		
		printf("Acquiring 1394 Camera(s).\n");
		CM = new CCameraFirewireCMU();
		
		
		int numc = CM->QueryCameras();
		if (numc > 0){
		
			CM->SelectCamera(0);
			CM->Initialize();
			CM->SetFormatModeFrameRate(0,5,30 );
			CM->StartImageAcquisitionExtended();
			
			
			strstream s;
			CM->GetCurrentSettings(s);
			printf("%s \n\n",s.str());	
			
			// capture 
			bool bOk = true;
			while (bOk){
				
				bOk = CM->AcquireExtended(img_a);
				glfwLockMutex( mutex );
					bNewThisFrame = true;
					memcpy(img_b, img_a, 640*480);
				glfwUnlockMutex( mutex );
				Sleep(20);
				
			}
		}
		
	}
}




//------------------------------------
fireWireCam::fireWireCam(){
	
	mutex = glfwCreateMutex();
	glfwCreateThread( fireCamThread, NULL );
	OT = new ofImgTex(1024, 512, GL_LUMINANCE);

	
}

//------------------------------------
fireWireCam::~fireWireCam(){
	CM->Close();
	glfwDestroyThread(thread);
	glfwDestroyMutex( mutex );

}

//------------------------------------
void fireWireCam::init(){
	
	
}

//------------------------------------
void fireWireCam::idle(){
	
	ofSetBgColor(0.0f,0.0, 0.0f, 0);
	
	bNew = false;
	// get image data
	glfwLockMutex( mutex );
		if (bNewThisFrame == true) {
			bNew = true;
			memcpy(img_c, img_b, 640*480);
			bNewThisFrame = false;
		}
	glfwUnlockMutex( mutex );

	if (bNew) OT->loadImageData(img_c, 640,480, GL_LUMINANCE);

	//printf("%f \n", ofGetFps());
	
}


//------------------------------------
void fireWireCam::draw(){
	
	glColor3f(1,1,1);
	//OT->renderTexture(0,480,640,-480);
	OT->renderTexture(0,768,1024,-768);
	
}



//------------------------------------
unsigned char *  fireWireCam::returnDataPtr(){
	return img_c;
}


//------------------------------------
void fireWireCam::keyDown  (char c){
	
	
	//CM->SetGainOn(true);
	//CM->SetAutoExposureOn(true);
	
	switch (c){
	
		case 'g': 
			CM->IncSharpness();
			printf("IncSharpness: %g\n", CM->GetSharpness()); 
			break;
		case 'b': 
			CM->DecSharpness();
			printf("DecSharpness: %g\n", CM->GetSharpness()); 
			break;
	
		case 'd': 
			CM->IncGamma();
			printf("IncGamma: %g\n", CM->GetGamma()); 
			break;
		case 'c': 
			CM->DecGamma();
			printf("DecGamma: %g\n", CM->GetGamma()); 
			break;
			
		case 'f': 
			CM->IncBrightness();
			printf("IncBrightness: %g\n", CM->GetBrightness()); 
			break;
		case 'v': 
			CM->DecBrightness();
			printf("DecBrightness: %g\n", CM->GetBrightness()); 
			break;
	
		case 'a':
			CM->IncGain();
			printf("IncGain: %g\n", CM->GetGain()); 
			break;
		case 'z':
			CM->DecGain();
			printf("DecGain: %g\n", CM->GetGain()); 
			break;
		case 's':
			CM->IncAutoExposure();
			printf("IncAutoExposure: %g\n", CM->GetAutoExposure());
			break;
		case 'x':
			CM->DecAutoExposure();
			printf("DecAutoExposure: %g\n", CM->GetAutoExposure());
			break;
	}
}



